/*
**
** global.h
**
*/

#ifndef _GLOBAL_H
#define _GLOBAL_H

#include <avr/io.h>
#include <stdio.h>
#include <stdint.h>
#include <avr/sleep.h>		// sleep function
#include <avr/interrupt.h> 
#include <stdlib.h>
#include <avr/wdt.h>			// watchdog


#ifndef EEPROM
#define EEPROM  __attribute__ ((section (".eeprom")))
#endif

// any powerfully Macros
#define sbi(p,n)        (p) |= (1<<(n))  			// set bit on PORT
#define cbi(p,n)        (p) &= ~(1<<(n)) 			// clear bit on PORT
#define outb(p,n)       (p) = (n)	     				// write to an PORT
#define inb(p)        	(p)		     						// read from an PORT
#define nop 						asm volatile ("nop")	// one machine clock


#define u08 uint8_t
#define u16 uint16_t
#define u32 uint32_t


/***********************************
**             Buzzer             
************************************/
#define BUZZER_PIN  PD7
#define BUZZER_DDR	DDRD
#define BUZZER_PORT	PORTD

/* 
** wachdog enabled or not
** by ATMega 8 must be set enable the wachdog with the seurity bits 
*/
#define WACHDOG_ENABLE    0




#endif // _GLOBAL_H


