#include "main.h"

/*
** delay ms routine
*/
void dms(unsigned int ms)
{
	unsigned int zaehler;
	while (ms)
	{
		zaehler = F_CPU / 5000;
		while (zaehler) {
			asm volatile ("nop");
			zaehler--;
		}
		ms--;
	}
}

/*
** delay ys routine
*/
void dus(unsigned int us)
{
	if (us < 4)
		return;
		
	if (us < 20)
		us-= 3;
		
	while (us)
	{
		asm volatile ("nop");
		us--;
	}
}

void Beep(u08 count, unsigned int le)
{
u08 i;
	
	for(i= 0;i < count; i++){
		sbi(BUZZER_PORT, BUZZER_PIN);
		dms(le);
		cbi(BUZZER_PORT, BUZZER_PIN);
		dms(le);													
	}
}

/*
** initializing 
*/
void Init(void){
	
	// init buzzer PIN
	sbi(BUZZER_DDR, BUZZER_PIN); // as output			 			
	cbi(BUZZER_PORT,BUZZER_PIN); // Pin is low
	
	
	//### GLOBAL INTERRUPT CONTROLLER ###
	// enable disable the interrupts over 
	// the global control register 
	GICR |= (1<<INT0); // enable INT0 - PD2
	GICR |= (1<<INT1); // enable INT1 - PD3
	GICR |= (1<<INT2); // enable INT2 - PB2
	
	// INT2 falling edge
  MCUCSR&= ~(1<<ISC2);	
	
	//### SET SLEEP MODE ###
	// SLEEP_MODE_IDLE
	// SLEEP_MODE_PWR_DOWN
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);

	//### INTERRUPT PINS INITIALIZATION ### 
	// as input to read from any key

	// INT0
	cbi(DDRD, PD2); 	// input for read
	sbi(PORTD,PD2);		// set pullups
	
	// INT1
	cbi(DDRD, PD3); 	// input for read
	sbi(PORTD,PD3);		// set pullups

	
	// INT2
	cbi(DDRB, PB2); 	// input for read
	sbi(PORTB,PB2);		// set pullups
	
	// wachdog enable 2 secounds
	//wdt_enable(WDTO_2S);	
}


/*
** INT0 - PD2
*/
ISR(INT0_vect)
{	
	Beep(3, 500);
	
	while ( bit_is_clear(PIND, PD2)){
		dms(1);
	}		
	
	gSleepCnt= 0;
	
	return;
}

/*
** INT1 - PD3
*/
ISR(INT1_vect)
{	
	Beep(5, 500);
	while ( bit_is_clear(PIND, PD3)){
		dms(1);
	}
	
	gSleepCnt= 0;
	
	return;
}

/*
** INT2 - PB2
*/
ISR(INT2_vect)
{	
	Beep(8, 500);
	while ( bit_is_clear(PINB, PB2)){
		dms(1);
	}
	
	gSleepCnt= 0;
	
	return;
}


/*
**############# MAIN ###########################
*/
int main(void) {
u08	gMainDelay;

	Init();
	sei();
	
	Beep(3,200); // init beep
	
	// init buzzer PIN
	sbi(BUZZER_DDR, BUZZER_PIN); // as output			 			
	cbi(BUZZER_PORT,BUZZER_PIN); // Pin is low
	
	// init member
	gMainDelay		= 1; // 1 ms delay
	gSleepDelTime	= 3000; // 3 secounds
	gSleepCnt			= gSleepDelTime; // now to sleep
	
	wdt_disable();
	
		
	//###############################################################################
	//### Main Loop function
	//###############################################################################
	for (;;) {
		
		//####
		// tue irgend was ....
		
		//### sleep
		if (gSleepCnt >= gSleepDelTime) { 
			gSleepCnt= 0;
			dms(1);
			sei();	
			Beep(1,1); 
			sleep_mode();
			
		}
		
	// increment the sleep counter
	gSleepCnt++;
		
	// main delay
	dms(gMainDelay);
	
	}// for (;;)
}
